/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM ../../../dist/idl/nsIActivityManager.idl
 */

#ifndef __gen_nsIActivityManager_h__
#define __gen_nsIActivityManager_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class mozIStorageConnection; /* forward declaration */

class nsIActivity; /* forward declaration */

class nsIActivityProcess; /* forward declaration */

class nsIVariant; /* forward declaration */


/* starting interface:    nsIActivityMgrListener */
#define NS_IACTIVITYMGRLISTENER_IID_STR "14cfad1c-3401-4c44-ab04-4a11b6662663"

#define NS_IACTIVITYMGRLISTENER_IID \
  {0x14cfad1c, 0x3401, 0x4c44, \
    { 0xab, 0x04, 0x4a, 0x11, 0xb6, 0x66, 0x26, 0x63 }}

class NS_NO_VTABLE nsIActivityMgrListener : public nsISupports {
 public:

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_IACTIVITYMGRLISTENER_IID)

  /* void onAddedActivity (in unsigned long aID, in nsIActivity aActivity); */
  NS_IMETHOD OnAddedActivity(uint32_t aID, nsIActivity *aActivity) = 0;

  /* void onRemovedActivity (in unsigned long aID); */
  NS_IMETHOD OnRemovedActivity(uint32_t aID) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsIActivityMgrListener, NS_IACTIVITYMGRLISTENER_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIACTIVITYMGRLISTENER \
  NS_IMETHOD OnAddedActivity(uint32_t aID, nsIActivity *aActivity) override; \
  NS_IMETHOD OnRemovedActivity(uint32_t aID) override; 

/* Use this macro when declaring the members of this interface when the
   class doesn't implement the interface. This is useful for forwarding. */
#define NS_DECL_NON_VIRTUAL_NSIACTIVITYMGRLISTENER \
  NS_METHOD OnAddedActivity(uint32_t aID, nsIActivity *aActivity); \
  NS_METHOD OnRemovedActivity(uint32_t aID); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIACTIVITYMGRLISTENER(_to) \
  NS_IMETHOD OnAddedActivity(uint32_t aID, nsIActivity *aActivity) override { return _to OnAddedActivity(aID, aActivity); } \
  NS_IMETHOD OnRemovedActivity(uint32_t aID) override { return _to OnRemovedActivity(aID); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIACTIVITYMGRLISTENER(_to) \
  NS_IMETHOD OnAddedActivity(uint32_t aID, nsIActivity *aActivity) override { return !_to ? NS_ERROR_NULL_POINTER : _to->OnAddedActivity(aID, aActivity); } \
  NS_IMETHOD OnRemovedActivity(uint32_t aID) override { return !_to ? NS_ERROR_NULL_POINTER : _to->OnRemovedActivity(aID); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsActivityMgrListener : public nsIActivityMgrListener
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIACTIVITYMGRLISTENER

  nsActivityMgrListener();

private:
  ~nsActivityMgrListener();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS(nsActivityMgrListener, nsIActivityMgrListener)

nsActivityMgrListener::nsActivityMgrListener()
{
  /* member initializers and constructor code */
}

nsActivityMgrListener::~nsActivityMgrListener()
{
  /* destructor code */
}

/* void onAddedActivity (in unsigned long aID, in nsIActivity aActivity); */
NS_IMETHODIMP nsActivityMgrListener::OnAddedActivity(uint32_t aID, nsIActivity *aActivity)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void onRemovedActivity (in unsigned long aID); */
NS_IMETHODIMP nsActivityMgrListener::OnRemovedActivity(uint32_t aID)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


/* starting interface:    nsIActivityManager */
#define NS_IACTIVITYMANAGER_IID_STR "9bfcc031-50e1-4d30-a35f-23509abcb8d1"

#define NS_IACTIVITYMANAGER_IID \
  {0x9bfcc031, 0x50e1, 0x4d30, \
    { 0xa3, 0x5f, 0x23, 0x50, 0x9a, 0xbc, 0xb8, 0xd1 }}

class NS_NO_VTABLE nsIActivityManager : public nsISupports {
 public:

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_IACTIVITYMANAGER_IID)

  /* unsigned long addActivity (in nsIActivity aActivity); */
  NS_IMETHOD AddActivity(nsIActivity *aActivity, uint32_t *_retval) = 0;

  /* void removeActivity (in unsigned long aID); */
  NS_IMETHOD RemoveActivity(uint32_t aID) = 0;

  /* nsIActivity getActivity (in unsigned long aID); */
  NS_IMETHOD GetActivity(uint32_t aID, nsIActivity * *_retval) = 0;

  /* boolean containsActivity (in unsigned long aID); */
  NS_IMETHOD ContainsActivity(uint32_t aID, bool *_retval) = 0;

  /* void getActivities (out unsigned long length, [array, size_is (length), retval] out nsIActivity aActivities); */
  NS_IMETHOD GetActivities(uint32_t *length, nsIActivity * **aActivities) = 0;

  /* void getProcessesByContext (in AString aContextType, in nsIVariant aContextObject, out unsigned long length, [array, size_is (length), retval] out nsIActivityProcess aProcesses); */
  NS_IMETHOD GetProcessesByContext(const nsAString & aContextType, nsIVariant *aContextObject, uint32_t *length, nsIActivityProcess * **aProcesses) = 0;

  /* void cleanUp (); */
  NS_IMETHOD CleanUp(void) = 0;

  /* readonly attribute long processCount; */
  NS_IMETHOD GetProcessCount(int32_t *aProcessCount) = 0;

  /* void addListener (in nsIActivityMgrListener aListener); */
  NS_IMETHOD AddListener(nsIActivityMgrListener *aListener) = 0;

  /* void removeListener (in nsIActivityMgrListener aListener); */
  NS_IMETHOD RemoveListener(nsIActivityMgrListener *aListener) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsIActivityManager, NS_IACTIVITYMANAGER_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIACTIVITYMANAGER \
  NS_IMETHOD AddActivity(nsIActivity *aActivity, uint32_t *_retval) override; \
  NS_IMETHOD RemoveActivity(uint32_t aID) override; \
  NS_IMETHOD GetActivity(uint32_t aID, nsIActivity * *_retval) override; \
  NS_IMETHOD ContainsActivity(uint32_t aID, bool *_retval) override; \
  NS_IMETHOD GetActivities(uint32_t *length, nsIActivity * **aActivities) override; \
  NS_IMETHOD GetProcessesByContext(const nsAString & aContextType, nsIVariant *aContextObject, uint32_t *length, nsIActivityProcess * **aProcesses) override; \
  NS_IMETHOD CleanUp(void) override; \
  NS_IMETHOD GetProcessCount(int32_t *aProcessCount) override; \
  NS_IMETHOD AddListener(nsIActivityMgrListener *aListener) override; \
  NS_IMETHOD RemoveListener(nsIActivityMgrListener *aListener) override; 

/* Use this macro when declaring the members of this interface when the
   class doesn't implement the interface. This is useful for forwarding. */
#define NS_DECL_NON_VIRTUAL_NSIACTIVITYMANAGER \
  NS_METHOD AddActivity(nsIActivity *aActivity, uint32_t *_retval); \
  NS_METHOD RemoveActivity(uint32_t aID); \
  NS_METHOD GetActivity(uint32_t aID, nsIActivity * *_retval); \
  NS_METHOD ContainsActivity(uint32_t aID, bool *_retval); \
  NS_METHOD GetActivities(uint32_t *length, nsIActivity * **aActivities); \
  NS_METHOD GetProcessesByContext(const nsAString & aContextType, nsIVariant *aContextObject, uint32_t *length, nsIActivityProcess * **aProcesses); \
  NS_METHOD CleanUp(void); \
  NS_METHOD GetProcessCount(int32_t *aProcessCount); \
  NS_METHOD AddListener(nsIActivityMgrListener *aListener); \
  NS_METHOD RemoveListener(nsIActivityMgrListener *aListener); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIACTIVITYMANAGER(_to) \
  NS_IMETHOD AddActivity(nsIActivity *aActivity, uint32_t *_retval) override { return _to AddActivity(aActivity, _retval); } \
  NS_IMETHOD RemoveActivity(uint32_t aID) override { return _to RemoveActivity(aID); } \
  NS_IMETHOD GetActivity(uint32_t aID, nsIActivity * *_retval) override { return _to GetActivity(aID, _retval); } \
  NS_IMETHOD ContainsActivity(uint32_t aID, bool *_retval) override { return _to ContainsActivity(aID, _retval); } \
  NS_IMETHOD GetActivities(uint32_t *length, nsIActivity * **aActivities) override { return _to GetActivities(length, aActivities); } \
  NS_IMETHOD GetProcessesByContext(const nsAString & aContextType, nsIVariant *aContextObject, uint32_t *length, nsIActivityProcess * **aProcesses) override { return _to GetProcessesByContext(aContextType, aContextObject, length, aProcesses); } \
  NS_IMETHOD CleanUp(void) override { return _to CleanUp(); } \
  NS_IMETHOD GetProcessCount(int32_t *aProcessCount) override { return _to GetProcessCount(aProcessCount); } \
  NS_IMETHOD AddListener(nsIActivityMgrListener *aListener) override { return _to AddListener(aListener); } \
  NS_IMETHOD RemoveListener(nsIActivityMgrListener *aListener) override { return _to RemoveListener(aListener); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIACTIVITYMANAGER(_to) \
  NS_IMETHOD AddActivity(nsIActivity *aActivity, uint32_t *_retval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->AddActivity(aActivity, _retval); } \
  NS_IMETHOD RemoveActivity(uint32_t aID) override { return !_to ? NS_ERROR_NULL_POINTER : _to->RemoveActivity(aID); } \
  NS_IMETHOD GetActivity(uint32_t aID, nsIActivity * *_retval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetActivity(aID, _retval); } \
  NS_IMETHOD ContainsActivity(uint32_t aID, bool *_retval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->ContainsActivity(aID, _retval); } \
  NS_IMETHOD GetActivities(uint32_t *length, nsIActivity * **aActivities) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetActivities(length, aActivities); } \
  NS_IMETHOD GetProcessesByContext(const nsAString & aContextType, nsIVariant *aContextObject, uint32_t *length, nsIActivityProcess * **aProcesses) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetProcessesByContext(aContextType, aContextObject, length, aProcesses); } \
  NS_IMETHOD CleanUp(void) override { return !_to ? NS_ERROR_NULL_POINTER : _to->CleanUp(); } \
  NS_IMETHOD GetProcessCount(int32_t *aProcessCount) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetProcessCount(aProcessCount); } \
  NS_IMETHOD AddListener(nsIActivityMgrListener *aListener) override { return !_to ? NS_ERROR_NULL_POINTER : _to->AddListener(aListener); } \
  NS_IMETHOD RemoveListener(nsIActivityMgrListener *aListener) override { return !_to ? NS_ERROR_NULL_POINTER : _to->RemoveListener(aListener); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsActivityManager : public nsIActivityManager
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIACTIVITYMANAGER

  nsActivityManager();

private:
  ~nsActivityManager();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS(nsActivityManager, nsIActivityManager)

nsActivityManager::nsActivityManager()
{
  /* member initializers and constructor code */
}

nsActivityManager::~nsActivityManager()
{
  /* destructor code */
}

/* unsigned long addActivity (in nsIActivity aActivity); */
NS_IMETHODIMP nsActivityManager::AddActivity(nsIActivity *aActivity, uint32_t *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void removeActivity (in unsigned long aID); */
NS_IMETHODIMP nsActivityManager::RemoveActivity(uint32_t aID)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsIActivity getActivity (in unsigned long aID); */
NS_IMETHODIMP nsActivityManager::GetActivity(uint32_t aID, nsIActivity * *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* boolean containsActivity (in unsigned long aID); */
NS_IMETHODIMP nsActivityManager::ContainsActivity(uint32_t aID, bool *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void getActivities (out unsigned long length, [array, size_is (length), retval] out nsIActivity aActivities); */
NS_IMETHODIMP nsActivityManager::GetActivities(uint32_t *length, nsIActivity * **aActivities)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void getProcessesByContext (in AString aContextType, in nsIVariant aContextObject, out unsigned long length, [array, size_is (length), retval] out nsIActivityProcess aProcesses); */
NS_IMETHODIMP nsActivityManager::GetProcessesByContext(const nsAString & aContextType, nsIVariant *aContextObject, uint32_t *length, nsIActivityProcess * **aProcesses)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void cleanUp (); */
NS_IMETHODIMP nsActivityManager::CleanUp()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute long processCount; */
NS_IMETHODIMP nsActivityManager::GetProcessCount(int32_t *aProcessCount)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void addListener (in nsIActivityMgrListener aListener); */
NS_IMETHODIMP nsActivityManager::AddListener(nsIActivityMgrListener *aListener)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void removeListener (in nsIActivityMgrListener aListener); */
NS_IMETHODIMP nsActivityManager::RemoveListener(nsIActivityMgrListener *aListener)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsIActivityManager_h__ */
