/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM ../../../dist/idl/nsIPKCS11Slot.idl
 */

#ifndef __gen_nsIPKCS11Slot_h__
#define __gen_nsIPKCS11Slot_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class nsIPK11Token; /* forward declaration */


/* starting interface:    nsIPKCS11Slot */
#define NS_IPKCS11SLOT_IID_STR "c2d4f296-ee60-11d4-998b-00b0d02354a0"

#define NS_IPKCS11SLOT_IID \
  {0xc2d4f296, 0xee60, 0x11d4, \
    { 0x99, 0x8b, 0x00, 0xb0, 0xd0, 0x23, 0x54, 0xa0 }}

class NS_NO_VTABLE nsIPKCS11Slot : public nsISupports {
 public:

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_IPKCS11SLOT_IID)

  /* readonly attribute AUTF8String name; */
  NS_IMETHOD GetName(nsACString & aName) = 0;

  /* readonly attribute AUTF8String desc; */
  NS_IMETHOD GetDesc(nsACString & aDesc) = 0;

  /* readonly attribute AUTF8String manID; */
  NS_IMETHOD GetManID(nsACString & aManID) = 0;

  /* readonly attribute AUTF8String HWVersion; */
  NS_IMETHOD GetHWVersion(nsACString & aHWVersion) = 0;

  /* readonly attribute AUTF8String FWVersion; */
  NS_IMETHOD GetFWVersion(nsACString & aFWVersion) = 0;

  enum {
    SLOT_DISABLED = 0U,
    SLOT_NOT_PRESENT = 1U,
    SLOT_UNINITIALIZED = 2U,
    SLOT_NOT_LOGGED_IN = 3U,
    SLOT_LOGGED_IN = 4U,
    SLOT_READY = 5U
  };

  /* readonly attribute unsigned long status; */
  NS_IMETHOD GetStatus(uint32_t *aStatus) = 0;

  /* nsIPK11Token getToken (); */
  NS_IMETHOD GetToken(nsIPK11Token * *_retval) = 0;

  /* readonly attribute AUTF8String tokenName; */
  NS_IMETHOD GetTokenName(nsACString & aTokenName) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsIPKCS11Slot, NS_IPKCS11SLOT_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIPKCS11SLOT \
  NS_IMETHOD GetName(nsACString & aName) override; \
  NS_IMETHOD GetDesc(nsACString & aDesc) override; \
  NS_IMETHOD GetManID(nsACString & aManID) override; \
  NS_IMETHOD GetHWVersion(nsACString & aHWVersion) override; \
  NS_IMETHOD GetFWVersion(nsACString & aFWVersion) override; \
  NS_IMETHOD GetStatus(uint32_t *aStatus) override; \
  NS_IMETHOD GetToken(nsIPK11Token * *_retval) override; \
  NS_IMETHOD GetTokenName(nsACString & aTokenName) override; 

/* Use this macro when declaring the members of this interface when the
   class doesn't implement the interface. This is useful for forwarding. */
#define NS_DECL_NON_VIRTUAL_NSIPKCS11SLOT \
  NS_METHOD GetName(nsACString & aName); \
  NS_METHOD GetDesc(nsACString & aDesc); \
  NS_METHOD GetManID(nsACString & aManID); \
  NS_METHOD GetHWVersion(nsACString & aHWVersion); \
  NS_METHOD GetFWVersion(nsACString & aFWVersion); \
  NS_METHOD GetStatus(uint32_t *aStatus); \
  NS_METHOD GetToken(nsIPK11Token * *_retval); \
  NS_METHOD GetTokenName(nsACString & aTokenName); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIPKCS11SLOT(_to) \
  NS_IMETHOD GetName(nsACString & aName) override { return _to GetName(aName); } \
  NS_IMETHOD GetDesc(nsACString & aDesc) override { return _to GetDesc(aDesc); } \
  NS_IMETHOD GetManID(nsACString & aManID) override { return _to GetManID(aManID); } \
  NS_IMETHOD GetHWVersion(nsACString & aHWVersion) override { return _to GetHWVersion(aHWVersion); } \
  NS_IMETHOD GetFWVersion(nsACString & aFWVersion) override { return _to GetFWVersion(aFWVersion); } \
  NS_IMETHOD GetStatus(uint32_t *aStatus) override { return _to GetStatus(aStatus); } \
  NS_IMETHOD GetToken(nsIPK11Token * *_retval) override { return _to GetToken(_retval); } \
  NS_IMETHOD GetTokenName(nsACString & aTokenName) override { return _to GetTokenName(aTokenName); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIPKCS11SLOT(_to) \
  NS_IMETHOD GetName(nsACString & aName) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetName(aName); } \
  NS_IMETHOD GetDesc(nsACString & aDesc) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetDesc(aDesc); } \
  NS_IMETHOD GetManID(nsACString & aManID) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetManID(aManID); } \
  NS_IMETHOD GetHWVersion(nsACString & aHWVersion) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetHWVersion(aHWVersion); } \
  NS_IMETHOD GetFWVersion(nsACString & aFWVersion) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetFWVersion(aFWVersion); } \
  NS_IMETHOD GetStatus(uint32_t *aStatus) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetStatus(aStatus); } \
  NS_IMETHOD GetToken(nsIPK11Token * *_retval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetToken(_retval); } \
  NS_IMETHOD GetTokenName(nsACString & aTokenName) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetTokenName(aTokenName); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsPKCS11Slot : public nsIPKCS11Slot
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIPKCS11SLOT

  nsPKCS11Slot();

private:
  ~nsPKCS11Slot();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS(nsPKCS11Slot, nsIPKCS11Slot)

nsPKCS11Slot::nsPKCS11Slot()
{
  /* member initializers and constructor code */
}

nsPKCS11Slot::~nsPKCS11Slot()
{
  /* destructor code */
}

/* readonly attribute AUTF8String name; */
NS_IMETHODIMP nsPKCS11Slot::GetName(nsACString & aName)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute AUTF8String desc; */
NS_IMETHODIMP nsPKCS11Slot::GetDesc(nsACString & aDesc)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute AUTF8String manID; */
NS_IMETHODIMP nsPKCS11Slot::GetManID(nsACString & aManID)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute AUTF8String HWVersion; */
NS_IMETHODIMP nsPKCS11Slot::GetHWVersion(nsACString & aHWVersion)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute AUTF8String FWVersion; */
NS_IMETHODIMP nsPKCS11Slot::GetFWVersion(nsACString & aFWVersion)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute unsigned long status; */
NS_IMETHODIMP nsPKCS11Slot::GetStatus(uint32_t *aStatus)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsIPK11Token getToken (); */
NS_IMETHODIMP nsPKCS11Slot::GetToken(nsIPK11Token * *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute AUTF8String tokenName; */
NS_IMETHODIMP nsPKCS11Slot::GetTokenName(nsACString & aTokenName)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsIPKCS11Slot_h__ */
