/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM ../../../dist/idl/nsIPgpMimeProxy.idl
 */

#ifndef __gen_nsIPgpMimeProxy_h__
#define __gen_nsIPgpMimeProxy_h__


#ifndef __gen_nsIStreamListener_h__
#include "nsIStreamListener.h"
#endif

#ifndef __gen_nsIURI_h__
#include "nsIURI.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
typedef int (*MimeDecodeCallbackFun)(const char *buf, int32_t buf_size, void *output_closure);
#define NS_PGPMIMEPROXY_CLASSNAME "PGP/Mime Decryption"
#define NS_PGPMIMEPROXY_CONTRACTID "@mozilla.org/mime/pgp-mime-decrypt;1"
#define NS_PGPMIMEPROXY_CID                     \
{ /* 6b7e094f-536b-40dc-b3a4-e3d729205ce1 */      \
   0x6b7e094f, 0x536b, 0x40dc,                    \
{0xb3, 0xa4, 0xe3, 0xd7, 0x29, 0x20, 0x5c, 0xe1 } }

/* starting interface:    nsIPgpMimeProxy */
#define NS_IPGPMIMEPROXY_IID_STR "6b7e094f-536b-40dc-b3a4-e3d729205ce1"

#define NS_IPGPMIMEPROXY_IID \
  {0x6b7e094f, 0x536b, 0x40dc, \
    { 0xb3, 0xa4, 0xe3, 0xd7, 0x29, 0x20, 0x5c, 0xe1 }}

class NS_NO_VTABLE nsIPgpMimeProxy : public nsIStreamListener {
 public:

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_IPGPMIMEPROXY_IID)

  /* [noscript] void setMimeCallback (in MimeDecodeCallbackFun outputFun, in voidPtr outputClosure, in nsIURI myUri); */
  NS_IMETHOD SetMimeCallback(MimeDecodeCallbackFun outputFun, void *outputClosure, nsIURI *myUri) = 0;

  /* void init (); */
  NS_IMETHOD Init(void) = 0;

  /* void write (in string buf, in unsigned long count); */
  NS_IMETHOD Write(const char * buf, uint32_t count) = 0;

  /* void finish (); */
  NS_IMETHOD Finish(void) = 0;

  /* attribute nsIStreamListener decryptor; */
  NS_IMETHOD GetDecryptor(nsIStreamListener * *aDecryptor) = 0;
  NS_IMETHOD SetDecryptor(nsIStreamListener *aDecryptor) = 0;

  /* attribute ACString contentType; */
  NS_IMETHOD GetContentType(nsACString & aContentType) = 0;
  NS_IMETHOD SetContentType(const nsACString & aContentType) = 0;

  /* attribute ACString mimePart; */
  NS_IMETHOD GetMimePart(nsACString & aMimePart) = 0;
  NS_IMETHOD SetMimePart(const nsACString & aMimePart) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsIPgpMimeProxy, NS_IPGPMIMEPROXY_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIPGPMIMEPROXY \
  NS_IMETHOD SetMimeCallback(MimeDecodeCallbackFun outputFun, void *outputClosure, nsIURI *myUri) override; \
  NS_IMETHOD Init(void) override; \
  NS_IMETHOD Write(const char * buf, uint32_t count) override; \
  NS_IMETHOD Finish(void) override; \
  NS_IMETHOD GetDecryptor(nsIStreamListener * *aDecryptor) override; \
  NS_IMETHOD SetDecryptor(nsIStreamListener *aDecryptor) override; \
  NS_IMETHOD GetContentType(nsACString & aContentType) override; \
  NS_IMETHOD SetContentType(const nsACString & aContentType) override; \
  NS_IMETHOD GetMimePart(nsACString & aMimePart) override; \
  NS_IMETHOD SetMimePart(const nsACString & aMimePart) override; 

/* Use this macro when declaring the members of this interface when the
   class doesn't implement the interface. This is useful for forwarding. */
#define NS_DECL_NON_VIRTUAL_NSIPGPMIMEPROXY \
  NS_METHOD SetMimeCallback(MimeDecodeCallbackFun outputFun, void *outputClosure, nsIURI *myUri); \
  NS_METHOD Init(void); \
  NS_METHOD Write(const char * buf, uint32_t count); \
  NS_METHOD Finish(void); \
  NS_METHOD GetDecryptor(nsIStreamListener * *aDecryptor); \
  NS_METHOD SetDecryptor(nsIStreamListener *aDecryptor); \
  NS_METHOD GetContentType(nsACString & aContentType); \
  NS_METHOD SetContentType(const nsACString & aContentType); \
  NS_METHOD GetMimePart(nsACString & aMimePart); \
  NS_METHOD SetMimePart(const nsACString & aMimePart); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIPGPMIMEPROXY(_to) \
  NS_IMETHOD SetMimeCallback(MimeDecodeCallbackFun outputFun, void *outputClosure, nsIURI *myUri) override { return _to SetMimeCallback(outputFun, outputClosure, myUri); } \
  NS_IMETHOD Init(void) override { return _to Init(); } \
  NS_IMETHOD Write(const char * buf, uint32_t count) override { return _to Write(buf, count); } \
  NS_IMETHOD Finish(void) override { return _to Finish(); } \
  NS_IMETHOD GetDecryptor(nsIStreamListener * *aDecryptor) override { return _to GetDecryptor(aDecryptor); } \
  NS_IMETHOD SetDecryptor(nsIStreamListener *aDecryptor) override { return _to SetDecryptor(aDecryptor); } \
  NS_IMETHOD GetContentType(nsACString & aContentType) override { return _to GetContentType(aContentType); } \
  NS_IMETHOD SetContentType(const nsACString & aContentType) override { return _to SetContentType(aContentType); } \
  NS_IMETHOD GetMimePart(nsACString & aMimePart) override { return _to GetMimePart(aMimePart); } \
  NS_IMETHOD SetMimePart(const nsACString & aMimePart) override { return _to SetMimePart(aMimePart); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIPGPMIMEPROXY(_to) \
  NS_IMETHOD SetMimeCallback(MimeDecodeCallbackFun outputFun, void *outputClosure, nsIURI *myUri) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SetMimeCallback(outputFun, outputClosure, myUri); } \
  NS_IMETHOD Init(void) override { return !_to ? NS_ERROR_NULL_POINTER : _to->Init(); } \
  NS_IMETHOD Write(const char * buf, uint32_t count) override { return !_to ? NS_ERROR_NULL_POINTER : _to->Write(buf, count); } \
  NS_IMETHOD Finish(void) override { return !_to ? NS_ERROR_NULL_POINTER : _to->Finish(); } \
  NS_IMETHOD GetDecryptor(nsIStreamListener * *aDecryptor) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetDecryptor(aDecryptor); } \
  NS_IMETHOD SetDecryptor(nsIStreamListener *aDecryptor) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SetDecryptor(aDecryptor); } \
  NS_IMETHOD GetContentType(nsACString & aContentType) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetContentType(aContentType); } \
  NS_IMETHOD SetContentType(const nsACString & aContentType) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SetContentType(aContentType); } \
  NS_IMETHOD GetMimePart(nsACString & aMimePart) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetMimePart(aMimePart); } \
  NS_IMETHOD SetMimePart(const nsACString & aMimePart) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SetMimePart(aMimePart); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsPgpMimeProxy : public nsIPgpMimeProxy
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIPGPMIMEPROXY

  nsPgpMimeProxy();

private:
  ~nsPgpMimeProxy();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS(nsPgpMimeProxy, nsIPgpMimeProxy)

nsPgpMimeProxy::nsPgpMimeProxy()
{
  /* member initializers and constructor code */
}

nsPgpMimeProxy::~nsPgpMimeProxy()
{
  /* destructor code */
}

/* [noscript] void setMimeCallback (in MimeDecodeCallbackFun outputFun, in voidPtr outputClosure, in nsIURI myUri); */
NS_IMETHODIMP nsPgpMimeProxy::SetMimeCallback(MimeDecodeCallbackFun outputFun, void *outputClosure, nsIURI *myUri)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void init (); */
NS_IMETHODIMP nsPgpMimeProxy::Init()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void write (in string buf, in unsigned long count); */
NS_IMETHODIMP nsPgpMimeProxy::Write(const char * buf, uint32_t count)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void finish (); */
NS_IMETHODIMP nsPgpMimeProxy::Finish()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute nsIStreamListener decryptor; */
NS_IMETHODIMP nsPgpMimeProxy::GetDecryptor(nsIStreamListener * *aDecryptor)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsPgpMimeProxy::SetDecryptor(nsIStreamListener *aDecryptor)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute ACString contentType; */
NS_IMETHODIMP nsPgpMimeProxy::GetContentType(nsACString & aContentType)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsPgpMimeProxy::SetContentType(const nsACString & aContentType)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute ACString mimePart; */
NS_IMETHODIMP nsPgpMimeProxy::GetMimePart(nsACString & aMimePart)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsPgpMimeProxy::SetMimePart(const nsACString & aMimePart)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsIPgpMimeProxy_h__ */
